<template>
  <Navbar />
  <!-- information -->
  <div class="movie" style="background-color: #111828;">
    
    <div class="container">
      <div class="video-container">
        <iframe :src="film.trailer" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>
      </div>
      
      <div class="movie-information" style="padding-top: 20px; padding-bottom: 20px; display: flex;">
        <div class="poster">
          <img :src="film.cover_image_url" style="width: 200px; height: 300px; border-radius: 10px;">
        </div>

        <div class="information" style="flex: 1; margin: 0px 20px;">
          <h1>{{ film.title }}</h1><br>
          <p>{{ film.synopsis }}</p>
          <table class="movie-details">
            <tr>
              <td class="label"><b>Director</b></td>
              <td>: {{ film.director }}</td>
            </tr>
            <tr>
              <td class="label"><b>Genre</b></td>
              <td>: {{ film.genre }}</td>
            </tr>
            <tr>
              <td class="label"><b>Rating</b></td>
              <td>: {{ film.min_rate }}</td>
            </tr>
            <tr>
              <td class="label"><b>Release Year</b></td>
              <td> : {{ film.release_year }}</td>
            </tr>
          </table>
        </div>

        <div style="border-left: 1px solid white; margin-top: 20px; margin-bottom: 20px;">

        </div>
        <div class="rating" style="width: 250px; display: flex; flex-direction: column;  align-items: center; padding-left: 20px;">
          <img src="https://img.freepik.com/premium-vector/javanese-hat-symbol-blangkon_757387-2379.jpg" class="logo" style="width: 70px; height: 70px; margin-bottom: 15px">
          
          <h4><b>{{ average_rating }}</b> / 5</h4>
          <h4><b> <span style="color: yellow;">AUDIENCE</span> SCORE</b></h4>
          <p style="text-align: center; font-style: italic;">
            The audience score only displays the arrange score assessment of all people.
          </p>
          <p style="text-align: center;"><span style="color: red; font-style: italic; font-size: 12px;">*Don’t get too hung up on people’s judgments.</span></p>
        </div>
      </div>
    </div>
  </div>

  <div class="container">

    <!-- Cast -->
    <div class="cast">
      <div class="movie-cast" style="padding-top: 20px;">
        <h1><span style="color:yellow">▏</span> Cast</h1>
        <p>The actors and actris who took part in the film making process</p>

        <div class="row row-cols-1 row-cols-md-6 g-4">
          <div class="cast" v-for="pemeran in pemerans" :key="pemeran.id" >
            <div class="cast-card">
              <img :src="pemeran.url_photo">
              <p>
                <b>{{ pemeran.name }}</b><br>
                {{ pemeran.casting }}
              </p>
            </div> 
          </div>
        </div>
        
      </div>
    </div>

    <!-- Reviews -->
    <div class="review">
      <h1><span style="color:#FFC94A">|</span> Reviews</h1>
      <p>Find out what other people think about this film</p>

      <div class="reviews-card">
        <div class="review-card" v-for="(review, index) in reviews" :key="review.id" :style="{ borderBottom: index === reviews.length - 1 ? 'none' : '1px solid white', marginBottom: index === reviews.length - 1 ? '0' : '20px' }">
          <table style="width: 100%">
            <p>
              <b>{{ review.user_name }}</b><br>
              <span style="color: yellow;">{{ review.review_date }}</span><br><br>

              {{ review.review_text }}
            </p>

            <!-- Menggunakan class "rating-thumb" -->
            <div class="rating-thumb" style="display: flex">
              <div style="margin-right: 40px; margin-left: auto">
                <p>⭐ {{ review.rating }}</p>
              </div>
              <div>
                <p>{{ review.thumbup }} <img style="width: 15px; height: 15px;" src="http://clipart-library.com/new_gallery/9-93530_facebook-thumb-up-icon-transparent-like-icon-png.png" alt=""></p>
              </div>
            </div>
          </table>
        </div>
      </div>
    </div>

    <!-- Comment -->
    <div v-if="isLoggedIn">
      <div class="form-floating">
        <textarea class="form-control" v-model="reviewText" placeholder="Leave a comment here" id="floatingTextarea2" style="height: 100px"></textarea>
        <label for="floatingTextarea2">Comments</label>
      </div>

      <!-- rating -->
      <div class="rating-wrapper">
        <input type="radio" v-model="rating" id="star-5" value="5"><label for="star-5"></label>
        <input type="radio" v-model="rating" id="star-4" value="4"><label for="star-4"></label>
        <input type="radio" v-model="rating" id="star-3" value="3"><label for="star-3"></label>
        <input type="radio" v-model="rating" id="star-2" value="2"><label for="star-2"></label>
        <input type="radio" v-model="rating" id="star-1" value="1"><label for="star-1"></label>
        <br><br><br>
        <p>~ Give a rating according to your opinion ~</p>
      </div>

      <div class="btn-comment" style="display: flex; justify-content: flex-end">
        <button @click="submitComment" class="btn btn-secondary">Post Comment</button>
      </div>
    </div>

    <div v-else>
      <p style="color: white; text-align: center; margin: 20px 0px">Login first to leave a review</p>
    </div>

  </div>
</template>

<script>
import Navbar from '@/components/Navbar.vue';
import axios from 'axios';

export default {
  name: 'FilmDetail',
  components: {
    Navbar
  },
  data() {
    return {
      film: {},
      average_rating: 0,
      pemeran: [],
      reviews: [],
      reviewText: '',
      rating: null,
      isLoggedIn: false // Add a new data property to track login status
    };
  },
  mounted() {
    // Check if user is logged in
    this.isLoggedIn = !!window.localStorage.getItem('jwt-token');

    // Fetch movie details
    const filmId = this.$route.params.id;
    axios.get(`http://localhost:8000/api/movie/${filmId}`)
      .then(response => {
        this.film = response.data.film;
        this.average_rating = response.data.average_rating;
        this.pemerans = response.data.pemerans;
        this.reviews = response.data.reviews;
      })
      .catch(error => {
        console.error('Error fetching film detail:', error);
      });
  },

  methods: {
    submitComment() {
      // Validasi
      if (!this.rating || !this.reviewText) {
        alert('Please provide both rating and review text.');
        return;
      }

      // Kirim ulasan ke backend
      const filmId = this.film.id;
      axios.post('http://localhost:8000/api/reviews', {
        film_id: filmId,
        review_text: this.reviewText,
        rating: this.rating
      }, {
        headers: {
          Authorization: 'Bearer ' + window.localStorage.getItem('jwt-token')
        }
      })
      .then(response => {
        // Reset formulir setelah berhasil mengirimkan komentar
        this.reviewText = '';
        this.rating = null;
        alert(response.data.message); // Tampilkan pesan respons dari backend
        window.location.reload(); // Memuat ulang halaman
      })
      .catch(error => {
        console.error('Error submitting review:', error);
        alert('Failed to submit review. Please try again later.'); // Tampilkan pesan kesalahan jika gagal
      });
    }
  }
};
</script>


<style>
body {
    background: #030814;
}

div {
  color: white;
}
.video-container {
  position: relative;
  width: 100%;
}

.video-container iframe {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

/* Mengatur tinggi video container agar sesuai dengan rasio lebar-tinggi */
.video-container::after {
  content: "";
  display: block;
  padding-bottom: 56.25%; /* Rasio lebar-tinggi 16:9 */
}

.label{
  width: 120px;
}

.cast-card img {
  border-radius: 50%;      /* Membuat foto menjadi lingkaran */
  width: 175px;            /* Lebar foto */
  height: 175px;           /* Tinggi foto */
  object-fit: cover;       /* Memastikan foto tetap proporsional */
}

.cast-card {
  text-align: center;
}
.cast-card p{
  margin-top: 10px;
}

.reviews-card {
  padding: 20px 20px 0px 20px;
  background-color: #111828;
  border-radius: 10px;
}

.rating-wrapper{
  direction: rtl;
  text-align: center;
}

.rating-wrapper input{
  display: none;
}

.rating-wrapper label{
  display: inline-block;
  width: 35px;
  position: relative;
  cursor: pointer;
}

.rating-wrapper label:before{
  content: "\2605";
  position: absolute;
  font-size: 30px;
  display: inline-block;
  top: 0;
  left: 0;
}

.rating-wrapper label:after{
  content: "\2605";
  position: absolute;
  font-size: 30px;
  display: inline-block;
  top: 0;
  left: 0;
  color: rgb(226, 208, 53);
  opacity: 0;
}

.rating-wrapper label:hover:after,
.rating-wrapper label:hover ~ label:after,
.rating-wrapper input:checked ~ label:after{
  opacity: 1;
}

.form-floating {
  margin-top: 20px;
}
</style>
